Index: trunk/NEMO/LIM_SRC/icestp.F90
===================================================================
--- trunk/NEMO/LIM_SRC/icestp.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/icestp.F90	(revision 258)
@@ -31,4 +31,5 @@
    USE limwri
    USE limrst
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -186,15 +187,15 @@
          
 
-         IF(l_ctl) THEN         ! print mean trends (used for debugging)
-            WRITE(numout,*) 'Ice Forcings '
-            WRITE(numout,*) ' qsr_oce  : ', SUM( qsr_oce (2:nictl,2:njctl) ), ' qsr_ice  : ', SUM( qsr_ice (2:nictl,2:njctl) )
-            WRITE(numout,*) ' qnsr_oce : ', SUM( qnsr_oce(2:nictl,2:njctl) ), ' qnsr_ice : ', SUM( qnsr_ice(2:nictl,2:njctl) )
-            WRITE(numout,*) ' evap     : ', SUM( evap    (2:nictl,2:njctl) )
-            WRITE(numout,*) ' precip   : ', SUM( tprecip(2:nictl,2:njctl)  ), ' Snow     : ', SUM( sprecip (2:nictl,2:njctl) )
-            WRITE(numout,*) ' u-stress : ', SUM( gtaux  (2:nictl,2:njctl)  ), ' v-stress : ', SUM( gtauy  (2:nictl,2:njctl) )
-            WRITE(numout,*) ' sst      : ', SUM( sst_io (2:nictl,2:njctl)  ), ' sss      : ', SUM( sss_io (2:nictl,2:njctl) )
-            WRITE(numout,*) ' u_io     : ', SUM( u_io   (2:nictl,2:njctl)  ), ' v_io     : ', SUM( v_io   (2:nictl,2:njctl) )
-            WRITE(numout,*) ' hsnif  1 : ', SUM( hsnif  (2:nictl,2:njctl)  ), ' hicnif   : ', SUM( hicif  (2:nictl,2:njctl) )
-            WRITE(numout,*) ' frld   1 : ', SUM( frld   (2:nictl,2:njctl)  ), ' sist     : ', SUM( sist   (2:nictl,2:njctl) )
+         IF(ln_ctl) THEN         ! print mean trends (used for debugging)
+            CALL prt_ctl_info('Ice Forcings ')
+            CALL prt_ctl(tab2d_1=qsr_oce ,clinfo1=' qsr_oce  : ', tab2d_2=qsr_ice , clinfo2=' qsr_ice   : ')
+            CALL prt_ctl(tab2d_1=qnsr_oce,clinfo1=' qnsr_oce : ', tab2d_2=qnsr_ice, clinfo2=' qnsr_ice  : ')
+            CALL prt_ctl(tab2d_1=evap    ,clinfo1=' evap     : ')
+            CALL prt_ctl(tab2d_1=tprecip ,clinfo1=' precip   : ', tab2d_2=sprecip , clinfo2=' Snow      : ')
+            CALL prt_ctl(tab2d_1=gtaux   ,clinfo1=' u-stress : ', tab2d_2=gtauy   , clinfo2=' v-stress  : ')
+            CALL prt_ctl(tab2d_1=sst_io  ,clinfo1=' sst      : ', tab2d_2=sss_io  , clinfo2=' sss       : ')
+            CALL prt_ctl(tab2d_1=u_io    ,clinfo1=' u_io     : ', tab2d_2=v_io    , clinfo2=' v_io      : ')
+            CALL prt_ctl(tab2d_1=hsnif   ,clinfo1=' hsnif  1 : ', tab2d_2=hicif   , clinfo2=' hicif     : ')
+            CALL prt_ctl(tab2d_1=frld    ,clinfo1=' frld   1 : ', tab2d_2=sist    , clinfo2=' sist      : ')
          ENDIF
 
@@ -205,7 +206,7 @@
          CALL lim_dyn                                                ! Ice dynamics !   ( rheology/dynamics )
          !                                                           !--------------!
-         IF(l_ctl) THEN
-            WRITE(numout,*) ' hsnif  2 : ', SUM( hsnif  (2:nictl,2:njctl) ), ' hicnif   : ', SUM( hicif  (2:nictl,2:njctl) )
-            WRITE(numout,*) ' frld   2 : ', SUM( frld   (2:nictl,2:njctl) ), ' sist     : ', SUM( sist   (2:nictl,2:njctl) )
+         IF(ln_ctl) THEN
+            CALL prt_ctl(tab2d_1=hsnif ,clinfo1=' hsnif  2 : ', tab2d_2=hicif , clinfo2=' hicif     : ')
+            CALL prt_ctl(tab2d_1=frld  ,clinfo1=' frld   2 : ', tab2d_2=sist  , clinfo2=' sist      : ')
          ENDIF
 
@@ -214,7 +215,7 @@
          CALL lim_trp                                                ! Ice transport !  ( Advection/diffusion )
          !                                                           !---------------!
-         IF(l_ctl) THEN
-            WRITE(numout,*) ' hsnif  3 : ', SUM( hsnif  (2:nictl,2:njctl) ), ' hicnif   : ', SUM( hicif  (2:nictl,2:njctl) )
-            WRITE(numout,*) ' frld   3 : ', SUM( frld   (2:nictl,2:njctl) ), ' sist     : ', SUM( sist   (2:nictl,2:njctl) )
+         IF(ln_ctl) THEN
+            CALL prt_ctl(tab2d_1=hsnif ,clinfo1=' hsnif  3 : ', tab2d_2=hicif , clinfo2=' hicif     : ')
+            CALL prt_ctl(tab2d_1=frld  ,clinfo1=' frld   3 : ', tab2d_2=sist  , clinfo2=' sist      : ')
          ENDIF
 
@@ -223,7 +224,7 @@
          CALL lim_thd                                                ! Ice thermodynamics !
          !                                                           !--------------------!
-         IF(l_ctl) THEN
-            WRITE(numout,*) ' hsnif  4 : ', SUM( hsnif  (2:nictl,2:njctl) ), ' hicnif   : ', SUM( hicif  (2:nictl,2:njctl) )
-            WRITE(numout,*) ' frld   4 : ', SUM( frld   (2:nictl,2:njctl) ), ' sist     : ', SUM( sist   (2:nictl,2:njctl) )
+         IF(ln_ctl) THEN
+            CALL prt_ctl(tab2d_1=hsnif ,clinfo1=' hsnif  4 : ', tab2d_2=hicif , clinfo2=' hicif     : ')
+            CALL prt_ctl(tab2d_1=frld  ,clinfo1=' frld   4 : ', tab2d_2=sist  , clinfo2=' sist      : ')
          ENDIF
 
Index: trunk/NEMO/LIM_SRC/limadv.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limadv.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limadv.F90	(revision 258)
@@ -17,4 +17,5 @@
    USE in_out_manager  ! I/O manager
    USE lbclnk
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -224,9 +225,9 @@
       CALL lbc_lnk( psxy, 'T', 1. )
 
-      IF(l_ctl) THEN
-         WRITE(numout,*) ' lim_adv_x: psm  ', SUM( psm (2:nictl,2:njctl) ), ' ps0  ', SUM( ps0 (2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_adv_x: psx  ', SUM( psx (2:nictl,2:njctl) ), ' psxx ', SUM( psxx(2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_adv_x: psy  ', SUM( psy (2:nictl,2:njctl) ), ' psyy ', SUM( psyy(2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_adv_x: psxy ', SUM( psxy(2:nictl,2:njctl) )
+      IF(ln_ctl)   THEN
+         CALL prt_ctl(tab2d_1=psm  , clinfo1=' lim_adv_x: psm  :', tab2d_2=ps0 , clinfo2=' ps0  : ')
+         CALL prt_ctl(tab2d_1=psx  , clinfo1=' lim_adv_x: psx  :', tab2d_2=psxx, clinfo2=' psxx : ')
+         CALL prt_ctl(tab2d_1=psy  , clinfo1=' lim_adv_x: psy  :', tab2d_2=psyy, clinfo2=' psyy : ')
+         CALL prt_ctl(tab2d_1=psxy , clinfo1=' lim_adv_x: psxy :')
       ENDIF
 
@@ -424,9 +425,9 @@
       CALL lbc_lnk( psxy, 'T', 1. )
 
-      IF(l_ctl) THEN
-         WRITE(numout,*) ' lim_adv_y: psm  ', SUM( psm (2:nictl,2:njctl) ), ' ps0  ', SUM( ps0 (2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_adv_y: psx  ', SUM( psx (2:nictl,2:njctl) ), ' psxx ', SUM( psxx(2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_adv_y: psy  ', SUM( psy (2:nictl,2:njctl) ), ' psyy ', SUM( psyy(2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_adv_y: psxy ', SUM( psxy(2:nictl,2:njctl) )
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab2d_1=psm  , clinfo1=' lim_adv_y: psm  :', tab2d_2=ps0 , clinfo2=' ps0  : ')
+         CALL prt_ctl(tab2d_1=psx  , clinfo1=' lim_adv_y: psx  :', tab2d_2=psxx, clinfo2=' psxx : ')
+         CALL prt_ctl(tab2d_1=psy  , clinfo1=' lim_adv_y: psy  :', tab2d_2=psyy, clinfo2=' psyy : ')
+         CALL prt_ctl(tab2d_1=psxy , clinfo1=' lim_adv_y: psxy :')
       ENDIF
 
Index: trunk/NEMO/LIM_SRC/limdyn.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limdyn.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limdyn.F90	(revision 258)
@@ -23,4 +23,5 @@
    USE lbclnk
    USE lib_mpp
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -92,5 +93,7 @@
             i_j1 = 1   
             i_jpj = jpj
-            IF(l_ctl)   WRITE(numout,*) 'lim_dyn :    i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
+            IF(ln_ctl)    THEN
+               CALL prt_ctl_info('lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj)
+            ENDIF
             CALL lim_rhg( i_j1, i_jpj )
 
@@ -113,5 +116,5 @@
                END DO
                i_j1 = MAX( 1, i_j1-1 )
-               IF(l_ctl)   WRITE(numout,*) 'lim_dyn : NH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
+               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : NH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
     
                CALL lim_rhg( i_j1, i_jpj )
@@ -124,5 +127,5 @@
                END DO
                i_jpj = MIN( jpj, i_jpj+2 )
-               IF(l_ctl)   WRITE(numout,*) 'lim_dyn : SH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
+               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : SH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
     
                CALL lim_rhg( i_j1, i_jpj )
@@ -143,5 +146,5 @@
                i_jpj = MIN( jpj, i_jpj+2)
     
-               IF(l_ctl)   WRITE(numout,*) 'lim_dyn : one hemisphere: i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
+               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : one hemisphere: i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
     
                CALL lim_rhg( i_j1, i_jpj )
@@ -154,7 +157,7 @@
          v_ice(:,1) = 0.e0
 
-         IF(l_ctl) THEN 
-            WRITE(numout,*) ' lim_dyn  : u_oce ', SUM( u_oce(2:nictl,2:njctl) ), ' v_oce ', SUM( v_oce(2:nictl,2:njctl) )
-            WRITE(numout,*) ' lim_dyn  : u_ice ', SUM( u_ice(2:nictl,2:njctl) ), ' v_ice ', SUM( v_ice(2:nictl,2:njctl) )
+         IF(ln_ctl)   THEN 
+            CALL prt_ctl(tab2d_1=u_oce , clinfo1=' lim_dyn  : u_oce :', tab2d_2=v_oce , clinfo2=' v_oce :')
+            CALL prt_ctl(tab2d_1=u_ice , clinfo1=' lim_dyn  : u_ice :', tab2d_2=v_ice , clinfo2=' v_ice :')
          ENDIF
          
@@ -244,7 +247,7 @@
       CALL lbc_lnk( tio_v, 'I', -1. )   ! I-point (i.e. ice U-V point)
 
-      IF(l_ctl) THEN 
-         WRITE(numout,*) ' lim_dyn  : tio_u ', SUM( tio_u(2:nictl,2:njctl) ), ' tio_v ', SUM( tio_v(2:nictl,2:njctl) )
-         WRITE(numout,*) ' lim_dyn  : ust2s ', SUM( ust2s(2:nictl,2:njctl) )
+      IF(ln_ctl) THEN 
+            CALL prt_ctl(tab2d_1=tio_u , clinfo1=' lim_dyn  : tio_u :', tab2d_2=tio_v , clinfo2=' tio_v :')
+            CALL prt_ctl(tab2d_1=ust2s , clinfo1=' lim_dyn  : ust2s :')
       ENDIF
 
Index: trunk/NEMO/LIM_SRC/limflx.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limflx.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limflx.F90	(revision 258)
@@ -11,14 +11,15 @@
    !!----------------------------------------------------------------------
    !! * Modules used
-   USE par_oce
-   USE phycst
-   USE ocfzpt
-   USE ice_oce
-   USE flx_oce
-   USE ice
-   USE flxblk
-   USE lbclnk
-   USE in_out_manager
-   USE albedo
+   USE par_oce          ! ocean parameters
+   USE phycst           ! physical constants
+   USE ocfzpt           ! surface ocean freezing point
+   USE ice_oce          ! sea-ice variable
+   USE flx_oce          ! sea-ice/ocean forcings variables
+   USE ice              ! LIM sea-ice variables
+   USE flxblk           ! bulk formulea
+   USE lbclnk           ! ocean lateral boundary condition
+   USE in_out_manager   ! I/O manager
+   USE albedo           ! albedo parameters
+   USE prtctl           ! Print control
 
    IMPLICIT NONE
@@ -195,10 +196,9 @@
 #endif
 
-      IF(l_ctl) THEN
-         WRITE(numout,*) ' lim_flx  '
-         WRITE(numout,*) ' fsolar ', SUM( fsolar(2:nictl,2:njctl) ), ' fnsolar', SUM( fnsolar(2:nictl,2:njctl) )
-         WRITE(numout,*) ' fmass  ', SUM( fmass (2:nictl,2:njctl) ), ' fsalt  ', SUM( fsalt  (2:nictl,2:njctl) )
-         WRITE(numout,*) ' ftaux  ', SUM( ftaux (2:nictl,2:njctl) ), ' ftauy  ', SUM( ftauy  (2:nictl,2:njctl) )
-         WRITE(numout,*) ' freeze ', SUM( freeze(2:nictl,2:njctl) ), ' tn_ice ', SUM( tn_ice (2:nictl,2:njctl) )
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab2d_1=fsolar, clinfo1=' lim_flx: fsolar : ', tab2d_2=fnsolar, clinfo2=' fnsolar : ')
+         CALL prt_ctl(tab2d_1=fmass , clinfo1=' lim_flx: fmass  : ', tab2d_2=fsalt  , clinfo2=' fsalt   : ')
+         CALL prt_ctl(tab2d_1=ftaux , clinfo1=' lim_flx: ftaux  : ', tab2d_2=ftauy  , clinfo2=' ftauy   : ')
+         CALL prt_ctl(tab2d_1=freeze, clinfo1=' lim_flx: freeze : ', tab2d_2=tn_ice , clinfo2=' tn_ice  : ')
       ENDIF 
    
Index: trunk/NEMO/LIM_SRC/limhdf.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limhdf.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limhdf.F90	(revision 258)
@@ -18,4 +18,5 @@
    USE lbclnk
    USE lib_mpp
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -67,4 +68,5 @@
       INTEGER ::  &
          its, iter            ! temporary integers
+      CHARACTER (len=55) :: charout
       REAL(wp) ::  &
          zalfa, zrlxint, zconv, zeps   ! temporary scalars
@@ -168,7 +170,9 @@
 
       ptab(:,:) = ptab(:,:)
-
-      IF(l_ctl)   WRITE(numout,*) ' lim_hdf  : ', SUM( ptab(2:nictl,2:njctl)-ptab0(2:nictl,2:njctl) ), &
-      &                                        ' zconv= ', zconv, ' iter= ', iter
+      IF(ln_ctl)   THEN
+         zrlx(:,:) = ptab(:,:) - ptab0(:,:)
+         WRITE(charout,FMT="(' lim_hdf  : zconv =',D23.16, ' iter =',I4,2X)") zconv, iter
+         CALL prt_ctl(tab2d_1=zrlx, clinfo1=charout)
+      ENDIF
 
    END SUBROUTINE lim_hdf
Index: trunk/NEMO/LIM_SRC/limrhg.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limrhg.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limrhg.F90	(revision 258)
@@ -19,4 +19,5 @@
    USE lib_mpp
    USE in_out_manager  ! I/O manager
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -64,4 +65,6 @@
          iim1, ijm1, iip1 , ijp1   , & ! temporary integers
          iter, jter                    !    "          "
+
+      CHARACTER (len=50) :: charout
 
       REAL(wp) :: &
@@ -632,7 +635,8 @@
       !                                                   ! ==================== !
 
-      IF(l_ctl) THEN
-         WRITE(numout,*) ' lim_rhg  : res= ', zresm, 'iter= ', jter,' u_ice ', SUM( u_ice(2:nictl,2:njctl) ) , &
-         &                                                          ' v_ice ', SUM( v_ice(2:nictl,2:njctl) )
+      IF(ln_ctl) THEN
+         WRITE(charout,FMT="('lim_rhg  : res =',D23.16, ' iter =',I4)") zresm, jter
+         CALL prt_ctl_info(charout)
+         CALL prt_ctl(tab2d_1=u_ice, clinfo1=' lim_rhg  : u_ice :', tab2d_2=v_ice, clinfo2=' v_ice :')
       ENDIF
 
Index: trunk/NEMO/LIM_SRC/limthd.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limthd.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limthd.F90	(revision 258)
@@ -25,4 +25,5 @@
    USE limthd_lac
    USE limtab
+   USE prtctl          ! Print control
       
    IMPLICIT NONE
@@ -78,4 +79,5 @@
          nbpb  ,               &   ! nb of icy pts for thermo. cal.
          nbpac                     ! nb of pts for lateral accretion 
+      CHARACTER (len=22) :: charout
       REAL(wp) ::  &
          zfric_umin = 5e-03 ,  &   ! lower bound for the friction velocity
@@ -92,4 +94,6 @@
          zhicifp            ,  &   ! ice thickness for outputs
          zqlbsbq                   ! link with lead energy budget qldif
+      REAL(wp), DIMENSION(jpi,jpj,2) :: &
+         zmsk                      ! working array
       !!-------------------------------------------------------------------
 
@@ -112,4 +116,5 @@
       rdmicif(:,:) = 0.e0   ! variation of ice mass per unit area
       hicifp (:,:) = 0.e0   ! daily thermodynamic ice production. 
+      zmsk (:,:,:) = 0.e0
 
       DO jj = 1, jpj
@@ -118,6 +123,6 @@
          END DO
       END DO
-      IF(l_ctl)   WRITE(numout,*) 'lim_thd  : ', SUM( hsnif(2:nictl,2:njctl) ) , ' hsnif'
-      
+
+      IF(ln_ctl)   CALL prt_ctl(tab2d_1=hsnif     , clinfo1=' lim_thd: hsnif   : ')
       
       !-----------------------------------!
@@ -150,10 +155,11 @@
          END DO
       END DO
-      IF(l_ctl) THEN
-         WRITE(numout,*) 'lim_thd: hicif : ', SUM( hicif (2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: hsnif : ', SUM( hsnif (2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: dmgwi : ', SUM( dmgwi (2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: qstoif: ', SUM( qstoif(2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: frld  : ', SUM( frld  (2:nictl,2:njctl) )
+
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab2d_1=hicif  , clinfo1=' lim_thd: hicif   : ')
+         CALL prt_ctl(tab2d_1=hsnif  , clinfo1=' lim_thd: hsnif   : ')
+         CALL prt_ctl(tab2d_1=dmgwi  , clinfo1=' lim_thd: dmgwi   : ')
+         CALL prt_ctl(tab2d_1=qstoif , clinfo1=' lim_thd: qstoif  : ')
+         CALL prt_ctl(tab2d_1=frld   , clinfo1=' lim_thd: frld    : ')
       ENDIF
 
@@ -221,12 +227,15 @@
          END DO
       END DO
-      IF(l_ctl) THEN
-         WRITE(numout,*) 'lim_thd: pfrld ' , SUM( pfrld  (2:nictl,2:njctl) ), ' thcm    ', SUM( thcm   (2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: fdtcn ' , SUM( fdtcn  (2:nictl,2:njctl) ), ' qdtcn   ', SUM( qdtcn  (2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: qldif ' , SUM( qldif  (2:nictl,2:njctl) ), ' zqlbsbq ', SUM( zqlbsbq(2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: qcmif ' , SUM( qcmif  (2:nictl,2:njctl) ), ' fbif    ', SUM( fbif   (2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: qcmif  ', SUM( qcmif  (2:nictl,2:njctl)*tms(2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd: zhicifp', SUM( zhicifp(2:nictl,2:njctl) )
-         WRITE(numout,*) 'limthd : nbpb = ', nbpb
+
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab2d_1=pfrld, clinfo1=' lim_thd: pfrld   : ', tab2d_2=thcm   , clinfo2='  thcm    : ')
+         CALL prt_ctl(tab2d_1=fdtcn, clinfo1=' lim_thd: fdtcn   : ', tab2d_2=qdtcn  , clinfo2='  qdtcn   : ')
+         CALL prt_ctl(tab2d_1=qldif, clinfo1=' lim_thd: qldif   : ', tab2d_2=zqlbsbq, clinfo2='  zqlbsbq : ')
+         CALL prt_ctl(tab2d_1=qcmif, clinfo1=' lim_thd: qcmif   : ', tab2d_2=fbif   , clinfo2='  fbif    : ')
+         zmsk(:,:,1) = tms(:,:)
+         CALL prt_ctl(tab2d_1=qcmif  , clinfo1=' lim_thd: qcmif   : ', mask1=zmsk)
+         CALL prt_ctl(tab2d_1=zhicifp, clinfo1=' lim_thd: zhicifp : ')
+         WRITE(charout, FMT="('lim_thd: nbpb = ',I4)") nbpb
+         CALL prt_ctl_info(charout)
       ENDIF
       
@@ -327,7 +336,8 @@
       END DO
       
-      IF(l_ctl) THEN
-         WRITE(numout,*) 'lim_thd : phicif ', SUM( phicif(2:nictl,2:njctl) ), ' hicif ', SUM( hicif(2:nictl,2:njctl) )
-         WRITE(numout,*) 'lim_thd : nbpac = ', nbpac
+      IF(ln_ctl) THEN
+         CALL prt_ctl(tab2d_1=phicif, clinfo1=' lim_thd: phicif  : ', tab2d_2=hicif, clinfo2=' hicif : ')
+         WRITE(charout, FMT="('lim_thd: nbpac = ',I4)") nbpac
+         CALL prt_ctl_info(charout)
       ENDIF
 
@@ -381,13 +391,15 @@
       END DO
 
-      IF(l_ctl) THEN
-         WRITE(numout,*) ' lim_thd  end  '
-         WRITE(numout,*) '  hicif ', SUM( hicif (2:nictl,2:njctl)   ), '  hsnif ', SUM( hsnif (2:nictl,2:njctl)   )
-         WRITE(numout,*) '  frld  ', SUM( frld  (2:nictl,2:njctl)   ), '  hicifp', SUM( hicifp(2:nictl,2:njctl)   )
-         WRITE(numout,*) '  phicif', SUM( phicif(2:nictl,2:njctl)   ), '  pfrld ', SUM( pfrld (2:nictl,2:njctl)   )
-         WRITE(numout,*) '  sist  ', SUM( sist  (2:nictl,2:njctl)   ), '  tbif 1', SUM( tbif  (2:nictl,2:njctl,1) )
-         WRITE(numout,*) '  tbif 2', SUM( tbif  (2:nictl,2:njctl,2) ), '  tbif 3', SUM( tbif  (2:nictl,2:njctl,3) )
-         WRITE(numout,*) '  fdtcn ', SUM( fdtcn (2:nictl,2:njctl)   ), '  qdtcn ', SUM( qdtcn (2:nictl,2:njctl)   )
-         WRITE(numout,*) '  qstoif', SUM( qstoif(2:nictl,2:njctl)   ), '  fsbbq ', SUM( fsbbq (2:nictl,2:njctl)   )
+      IF(ln_ctl) THEN
+         CALL prt_ctl_info(' lim_thd  end  ')
+         CALL prt_ctl(tab2d_1=hicif , clinfo1=' lim_thd: hicif   : ', tab2d_2=hsnif , clinfo2=' hsnif  : ')
+         CALL prt_ctl(tab2d_1=frld  , clinfo1=' lim_thd: frld    : ', tab2d_2=hicifp, clinfo2=' hicifp : ')
+         CALL prt_ctl(tab2d_1=phicif, clinfo1=' lim_thd: phicif  : ', tab2d_2=pfrld , clinfo2=' pfrld  : ')
+         CALL prt_ctl(tab2d_1=sist  , clinfo1=' lim_thd: sist    : ')
+         CALL prt_ctl(tab2d_1=tbif(:,:,1), clinfo1=' lim_thd: tbif 1  : ')
+         CALL prt_ctl(tab2d_1=tbif(:,:,2), clinfo1=' lim_thd: tbif 2  : ')
+         CALL prt_ctl(tab2d_1=tbif(:,:,3), clinfo1=' lim_thd: tbif 3  : ')
+         CALL prt_ctl(tab2d_1=fdtcn , clinfo1=' lim_thd: fdtcn   : ', tab2d_2=qdtcn , clinfo2=' qdtcn  : ')
+         CALL prt_ctl(tab2d_1=qstoif, clinfo1=' lim_thd: qstoif  : ', tab2d_2=fsbbq , clinfo2=' fsbbq  : ')
       ENDIF
 
Index: trunk/NEMO/LIM_SRC/limwri.F90
===================================================================
--- trunk/NEMO/LIM_SRC/limwri.F90	(revision 257)
+++ trunk/NEMO/LIM_SRC/limwri.F90	(revision 258)
@@ -136,5 +136,5 @@
       !-----------------------------------------------------------------------
 
-      IF(lwp .AND. L_ctl) THEN
+      IF(lwp) THEN
          WRITE(numout,*)
          WRITE(numout,*) 'lim_wri : write ice outputs in NetCDF files at time : ', nyear, nmonth, nday, numit
Index: trunk/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 258)
@@ -66,4 +66,5 @@
    INTEGER, PUBLIC, DIMENSION(jpnij) ::   &  !:
       nimppt, njmppt,  &  !: i-, j-indexes for each processor
+      ibonit, ibonjt,  &  !: i-, j- processor neighbour existence
       nlcit, nlcjt,    &  !: dimensions of every subdomain
       nldit, nldjt,    &  !: first, last indoor index for each i-domain
Index: trunk/NEMO/OPA_SRC/DOM/domain.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DOM/domain.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DOM/domain.F90	(revision 258)
@@ -156,8 +156,9 @@
       !! * Modules used
       USE ioipsl
-      NAMELIST/namrun/ no    , cexper   , ln_rstart , nrstdt , nit000,         &
-         &             nitend, ndate0   , nleapy   , ninist , nstock,          &
-         &             nprint, nwrite   , nrunoff  , ln_ctl , nictl , njctl,   &
-         &             nbench
+      NAMELIST/namrun/ no    , cexper   , ln_rstart , nrstdt , nit000,          &
+         &             nitend, ndate0   , nleapy   , ninist , nstock,           &
+         &             nprint, nwrite   , nrunoff  , ln_ctl , nictls, nictle,   &
+         &             njctls, njctle   , nbench   , isplt  , jsplt
+
       NAMELIST/namdom/ ntopo , e3zps_min, e3zps_rat, ngrid  , nmsh  ,   &
          &             nacc  , atfp     , rdt      , rdtmin , rdtmax,   &
@@ -192,13 +193,76 @@
          WRITE(numout,*) '           runoff option                   nrunoff   = ', nrunoff
          WRITE(numout,*) '           run control (for debugging)     ln_ctl    = ', ln_ctl
-         WRITE(numout,*) '           Max i indice for SUM control    nictl     = ', nictl
-         WRITE(numout,*) '           Max j indice for SUM control    njctl     = ', njctl
+         WRITE(numout,*) '           Start i indice for SUM control  nictls    = ', nictls
+         WRITE(numout,*) '           End i indice for SUM control    nictle    = ', nictle
+         WRITE(numout,*) '           Start j indice for SUM control  njctls    = ', njctls
+         WRITE(numout,*) '           End j indice for SUM control    njctle    = ', njctle
+         WRITE(numout,*) '           number of proc. following i     isplt     = ', isplt
+         WRITE(numout,*) '           number of proc. following j     jsplt     = ', jsplt
          WRITE(numout,*) '           benchmark parameter (0/1)       nbench    = ', nbench
       ENDIF
 
-      l_ctl = ln_ctl .AND. lwp       ! trend control print on the 1st processor only
-
       ndastp = ndate0                ! Assign initial date to current date
 
+! ... Control the sub-domain area indices for the print control
+      IF(ln_ctl)   THEN
+         IF( lk_mpp ) THEN
+            ! the domain is forced to the real splitted domain in MPI
+            isplt = jpni ; jsplt = jpnj ; ijsplt = jpni*jpnj
+         ELSE
+            IF( isplt == 1 .AND. jsplt == 1  ) THEN
+               IF(lwp) WRITE(numout,cform_war)
+               IF(lwp) WRITE(numout,*)'          - isplt & jsplt are equal to 1'
+               IF(lwp) WRITE(numout,*)'          - the print control will be done over the whole domain'
+               IF(lwp) WRITE(numout,*)
+            ENDIF
+
+            ! compute the total number of processors ijsplt
+            ijsplt = isplt*jsplt
+         ENDIF
+
+         IF(lwp) WRITE(numout,*)'          - The total number of processors over which the'
+         IF(lwp) WRITE(numout,*)'            print control will be done is ijsplt : ', ijsplt
+
+         ! Control the indices used for the SUM control
+         IF( nictls+nictle+njctls+njctle == 0 )   THEN
+            ! the print control is done over the default area
+            lsp_area = .FALSE.
+         ELSE
+            ! the print control is done over a specific  area
+            lsp_area = .TRUE.
+            IF( nictls < 1 .OR. nictls > jpiglo )   THEN
+               IF(lwp) WRITE(numout,cform_war)
+               IF(lwp) WRITE(numout,*)'          - nictls must be 1<=nictls>=jpiglo, it is forced to 1'
+               IF(lwp) WRITE(numout,*)
+               nwarn = nwarn + 1
+               nictls = 1
+            ENDIF
+
+            IF( nictle < 1 .OR. nictle > jpiglo )   THEN
+               IF(lwp) WRITE(numout,cform_war)
+               IF(lwp) WRITE(numout,*)'          - nictle must be 1<=nictle>=jpiglo, it is forced to jpiglo'
+               IF(lwp) WRITE(numout,*)
+               nwarn = nwarn + 1
+               nictle = jpjglo
+            ENDIF
+
+            IF( njctls < 1 .OR. njctls > jpjglo )   THEN
+               IF(lwp) WRITE(numout,cform_war)
+               IF(lwp) WRITE(numout,*)'          - njctls must be 1<=njctls>=jpjglo, it is forced to 1'
+               IF(lwp) WRITE(numout,*)
+               nwarn = nwarn + 1
+               njctls = 1
+            ENDIF
+
+            IF( njctle < 1 .OR. njctle > jpjglo )   THEN
+               IF(lwp) WRITE(numout,cform_war)
+               IF(lwp) WRITE(numout,*)'          - njctle must be 1<=njctle>= jpjglo, it is forced to jpjglo'
+               IF(lwp) WRITE(numout,*)
+               nwarn = nwarn + 1
+               njctle = jpjglo
+            ENDIF
+
+         ENDIF          ! IF( nictls+nictle+njctls+njctle == 0 )
+       ENDIF            ! IF(ln_ctl)
 
 ! ... Control of output frequency
@@ -247,25 +311,4 @@
          WRITE(numout,*) '           nb of seconds per year   raass = ', raass, ' s'
          WRITE(numout,*) '           nb of seconds per month  rmoss = ', rmoss, ' s'
-      ENDIF
-
-! ... Control the Max i and j indices used for the SUM control (i.e. when ln_ctl=.true.)
-      IF ( nictl > jpim1 ) THEN
-          IF(lwp) THEN
-             WRITE(numout,cform_war)
-             WRITE(numout,*) '           nictl = ', nictl, ' must be <= to jpim1 '
-             WRITE(numout,*) '           nictl forced to be equal to jpim1 '
-          ENDIF
-          nwarn = nwarn + 1
-          nictl = jpim1
-      ENDIF
-
-      IF ( njctl > jpjm1 ) THEN
-          IF(lwp) THEN
-             WRITE(numout,cform_war)
-             WRITE(numout,*) '           njctl = ', njctl, ' must be <= to jpjm1 '
-             WRITE(numout,*) '           njctl forced to be equal to jpjm1 '
-          ENDIF
-          nwarn = nwarn + 1
-          njctl = jpjm1
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynhpg.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynhpg.F90	(revision 258)
@@ -21,4 +21,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -172,9 +173,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zuap = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zvap = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' hpg  - Ua: ', zuap-u_ctl, ' Va: ', zvap-v_ctl
-         u_ctl = zuap   ;   v_ctl = zvap
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -325,9 +324,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zuap = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zvap = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' hpg  - Ua: ', zuap-u_ctl, ' Va: ', zvap-v_ctl
-         u_ctl = zuap   ;   v_ctl = zvap
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -443,9 +440,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zuap = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zvap = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' hpg  - Ua: ', zuap-u_ctl, ' Va: ', zvap-v_ctl
-         u_ctl = zuap   ;   v_ctl = zvap
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
Index: trunk/NEMO/OPA_SRC/DYN/dynhpg_atsk.F90
===================================================================
--- trunk/NEMO/OPA_SRC/DYN/dynhpg_atsk.F90	(revision 257)
+++ trunk/NEMO/OPA_SRC/DYN/dynhpg_atsk.F90	(revision 258)
@@ -21,4 +21,5 @@
    USE trdmod          ! ocean dynamics trends 
    USE trdmod_oce      ! ocean variables trends
+   USE prtctl          ! Print control
 
    IMPLICIT NONE
@@ -162,9 +163,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zuap = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zvap = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' hpg  - Ua: ', zuap-u_ctl, ' Va: ', zvap-v_ctl
-         u_ctl = zuap   ;   v_ctl = zvap
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
@@ -306,9 +305,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zuap = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zvap = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' hpg  - Ua: ', zuap-u_ctl, ' Va: ', zvap-v_ctl
-         u_ctl = zuap   ;   v_ctl = zvap
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF   
 
@@ -429,9 +426,7 @@
       ENDIF
 
-      IF(l_ctl) THEN         ! print sum trends (used for debugging)
-         zuap = SUM( ua(2:nictl,2:njctl,1:jpkm1) * umask(2:nictl,2:njctl,1:jpkm1) )
-         zvap = SUM( va(2:nictl,2:njctl,1:jpkm1) * vmask(2:nictl,2:njctl,1:jpkm1) )
-         WRITE(numout,*) ' hpg  - Ua: ', zuap-u_ctl, ' Va: ', zvap-v_ctl
-         u_ctl = zuap   ;   v_ctl = zvap
+      IF(ln_ctl) THEN         ! print sum trends (used for debugging)
+         CALL prt_ctl(tab3d_1=ua, clinfo1=' hpg  - Ua: ', mask1=umask, &
+            &         tab3d_2=va, clinfo2=' Va: ', mask2=vmask, clinfo3='dyn')
       ENDIF
 
